SystemOrganization addCategory: #'Poll-Commands'!
SystemOrganization addCategory: #'Poll-Model'!
SystemOrganization addCategory: #'Poll-Visitor'!
SystemOrganization addCategory: #'Poll-View'!

!PRVisitor methodsFor: '*Poll' stamp: 'pmm 12/18/2005 17:07'!
visitPoll: aPoll
	self visitStructure: aPoll! !

!PRViewRenderer methodsFor: '*Poll' stamp: 'pmm 2/11/2006 08:42'!
visitPoll: aPoll
	html render: (aPoll asComponent readonly: true; yourself)! !

PRCommand subclass: #POVoteCommand
	instanceVariableNames: 'vote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:28'!
hasAlreadyVoted
	| cookies poll |
	cookies := WACurrentSession value currentRequest cookies.
	poll := PRCurrentContext value structure.
	^(cookies includesKey: poll cookieName)! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 12/22/2005 16:21'!
isAbstract
	^false! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^WACurrentSession value notNil! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:26'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ self isHttp not or: [ self hasAlreadyVoted not ] ]! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:28'!
label
	^'Vote'! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 1/29/2006 11:41'!
structureClass
	^POPoll ! !

!POVoteCommand methodsFor: 'private' stamp: 'pmm 2/10/2006 19:43'!
addCookie
	| voteCookie |
	voteCookie := (WACookie
		key: self structure cookieName
		value: self vote text)
		expiry: (DateAndTime year: 2095 month: 1 day: 1 hour: 12 minute: 0);
		yourself.
	self session redirectWithCookies: (Array with: voteCookie)! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
description
	^super description copy
		add: self descriptionVote;
		yourself! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
descriptionVote
	^(MASingleOptionDescription selector: #vote label: 'Vote' priority: 200)
		options: self options;
		reference: (POPollOption description
			stringWriter: POLabelWriter;
			yourself);
		componentClass: MARadioGroupComponent;
		beRequired;
		yourself! !

!POVoteCommand methodsFor: 'events' stamp: 'pmm 1/28/2006 10:23'!
doExecute
	super doExecute.
	self vote addVote.
	self isHttp
		ifTrue: [ self addCookie ]! !

!POVoteCommand methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^self class isHttp ! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:29'!
options
	^self structure options! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 20:13'!
session
	^WACurrentSession value! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:36'!
vote
	^vote! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 19:42'!
vote: aPollOption 
	vote := aPollOption! !

MAStringWriter subclass: #POLabelWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Visitor'!

!POLabelWriter methodsFor: 'visiting' stamp: 'pmm 12/22/2005 16:27'!
write: anObject description: aDescription
	^anObject label! !

PRObject subclass: #POPollOption
	instanceVariableNames: 'text votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionText
	^(MAStringDescription selector: #text label: 'Text' priority: 100)
		beRequired;
		yourself! !

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionVotes
	^(MANumberDescription selector: #votes label: 'Votes' priority: 200)
		default: 0;
		beHidden;
		yourself! !

!POPollOption class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:39'!
isAbstract
	^false! !

!POPollOption methodsFor: 'actions' stamp: 'pmm 12/22/2005 16:45'!
addVote
	self votes: self votes + 1! !

!POPollOption methodsFor: 'testing' stamp: 'pmm 2/10/2006 20:12'!
hasVotes
	^self votes isZero not! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/22/2005 16:28'!
label
	^self text! !

!POPollOption methodsFor: 'copying' stamp: 'pmm 3/3/2006 20:27'!
postCopy
	super postCopy.
	self votes: 0! !

!POPollOption methodsFor: 'printing' stamp: 'pmm 12/22/2005 16:34'!
printOn: aStream
	super printOn: aStream.
	self text isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self text;
			nextPut: $) ]! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
text
	^text! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
text: aString 
	text := aString! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
votes
	^votes! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
votes: anInteger 
	votes := anInteger! !

PRStructure subclass: #POPoll
	instanceVariableNames: 'options uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 3/3/2006 20:10'!
descriptionOptions
	^(MAToManyRelationDescription selector: #options label: 'Options' priority: 200)
		propertyAt: #editable put: true;
		classes: (Array with: POPollOption);
		default: OrderedCollection new;
		yourself.! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 16:37'!
descriptionTitle
	^super descriptionTitle
		label: 'Question';
		yourself! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 1/28/2006 10:04'!
descriptionUUID
	^ (MAStringDescription selector: #uuid label: 'UUId' priority: 1000)
		beHidden;
		beReadonly;
		yourself.! !

!POPoll class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:45'!
isAbstract
	^false! !

!POPoll class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:48'!
label
	^'Poll'! !

!POPoll methodsFor: 'visiting' stamp: 'pmm 12/18/2005 17:08'!
accept: aVisitor
	aVisitor visitPoll: self.! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:20'!
cookieName
	^'pierPoll' , self uuid! !

!POPoll methodsFor: 'initialize-release' stamp: 'pmm 1/28/2006 10:03'!
initialize
	super initialize.
	uuid := UUID new printString.
	self options: OrderedCollection new! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options
	^options! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options: aCollection 
	options := aCollection! !

!POPoll methodsFor: 'copying' stamp: 'pmm 3/3/2006 20:29'!
postCopy
	super postCopy.
	self options: (self options collect: [ :each | each copy ])! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:45'!
totalVotes
	^self options inject: 0 into: [ :sum :each |
		sum + each votes ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:02'!
uuid
	^uuid! !

PRViewComponent subclass: #POPollResultsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

POPollResultsView subclass: #POCanvasPollResultsView
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 16:44'!
isAbstract
	^false! !

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:35'!
isSupported
	^self environment hasClassNamed: #CGPieChart! !

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 17:07'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]! !

!POCanvasPollResultsView class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:41'!
label
	^'View Canvas'! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:43'!
chart
	chart isNil ifTrue: [
		self createPieChart ].
	^chart! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:12'!
chart: anObject
	chart := anObject! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:13'!
children
	^Array with: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 3/3/2006 20:42'!
createPieChart
	self chart: CGPieChart new.
	self chart addDataset: self dataset.
	self chart xLabels: self xLabels.
	self chart fontSize: 12.
	self chart labelWidth: 100.
	self chart width: self chartWidth height: self chartHeight.
	self chart paddingTop: 50 left: 50 bottom: 50 right: 50.
	self chart id: 'result' , self poll name! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 1/3/2006 10:14'!
dataset
	| index data |
	index := 0.
	data := self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		Array with: index with: each votes ].
	^CGDataset name: self poll title data: data! !

!POCanvasPollResultsView methodsFor: 'rendering' stamp: 'pmm 12/22/2005 17:17'!
renderContentOn: html
	html render: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 3/3/2006 20:51'!
xLabels
	| index labels |
	labels := Dictionary new.
	index := 0.
	self pollOptionsWithVotes do: [ :each |
		index := index + 1.
		labels at: index put: each text ].
	^labels! !

POPollResultsView subclass: #POMorphPollResultsView
	instanceVariableNames: 'morph morphUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POMorphPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/10/2006 21:57'!
isAbstract
	^false! !

!POMorphPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:33'!
isSupported
	^self environment hasClassNamed: #PCPieChartMorph! !

!POMorphPollResultsView class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:41'!
label
	^'View Morph'! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:14'!
createMorph
	| values |
	values := self pollOptionValues.
	morph := PCPieChartMorph values: values.
	morph extent: self chartWidth @ self chartHeight.
	morph colors: (Color wheel: values size saturation: 0.25 brightness: 1).
	morph references: self pollOptionLabels.
	morph showLabels! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:39'!
morph
	morph isNil ifTrue: [
		self createMorph ].
	^morph! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 3/3/2006 20:40'!
morphUrlIn: html
	morphUrl isNil ifTrue: [
		morphUrl := html context
			urlForDocument: self morph
			mimeType: 'image/gif' ].
	^morphUrl! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 23:27'!
pollOptionLabels
	| amount |
	amount := self pollOptionsWithVotes inject: 0 into: [ :sum : each | sum + each votes ].
	^self pollOptionsWithVotes collect: [ :each |
		String streamContents: [ :stream |
			stream
				nextPutAll: each text;
				nextPutAll: ' (';
				nextPutAll: (100 * each votes // amount) displayString;
				nextPutAll: '%)' ] ]! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 22:49'!
pollOptionValues
	^self pollOptionsWithVotes collect: [ :each | each votes ]! !

!POMorphPollResultsView methodsFor: 'rendering' stamp: 'pmm 2/10/2006 23:17'!
renderContentOn: html
	html image
		width: self chartWidth;
		height: self chartHeight;
		altText: 'poll results';
		url: (self morphUrlIn: html)! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 3/3/2006 20:50'!
isSupported
	self subclassResponsibility ! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:35'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]
		and: [ self isSupported ]! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartHeight
	^400! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartWidth
	^400! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:54'!
name
	^self poll title! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:32'!
poll
	^self context structure! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptions
	^self poll options! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptionsWithVotes
	^self pollOptions select: [ :each | each hasVotes ]! !

MADistribution subclass: #P0Distribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
package
	"The SqueakMap package name."

	^ 'Poll'! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
packages
	^ #( ( 'Poll' ) )! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:22'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( poll 0 9 1 pre1 )! !
